\chapter{ Methods \label{ch:mtd} } 

%\begin{figure}[h] 
%	\begin{center} 
%		\includegraphics[width=.7\linewidth]{Figures/Renders-01/setup01-together.png} 
%	\end{center} 
%	\caption{ 3D model of the experimental setup. \label{fig:exp-01-pretty-model} } 
%\end{figure} 

%This section describes how we went from investigating the magnets to running the fluid flow and the data. 

We designed three magnet arrangements, and we called them \textit{Setup-1}, \textit{Setup-2}, and \textit{Setup-3}. However, we built and tested only Setup-1 and Setup-3 because the second was too complicated to 3D-print and to build. In this chapter, we will begin by describing Setup-3 and why it is important. Then we will describe our data collection procedures. Finally, we will finish by noting that we had also built Setup-1 and our reasons for it. \\




\section{ Design of Setup-3 \label{section:mtd:target-setup} } 

As described in \chp{ch:intro} and \chp{ch:bg}, the experiment used magnets and the Lorentz force to drive a water current. However, the magnets needed to be held in place, the parts needed to be centered, and other considerations needed to be made. This chapter describes Setup-3. \\

\begin{figure}[!ht] 
	\begin{center} 
		\raisebox{-.5\height}{\includegraphics[width=3in]{Figures/Renders-01/setup-03-b-apart.png}} 
	\end{center} 
	\caption{ An assembly drawing of Setup-3. At the bottom is a stand that holds up a tray with a magnet arrangement. This magnet arrangement creates a magnetic field at the surface of the water in the cell sitting on top of the magnet tray. A cylindrical part centers the system. \label{fig:dis-setup-03} } 
\end{figure} 


The setup needed to drive a disk-shaped fluid flow, partly mimicking the shape of accretion disks. To drive the flow, we used permanent magnets to create a magnetic field with a square-root profile, as \eqn{eqn:B-k-prop} tells us it needs to be a square-root profile. In order to create the desired magnetic field, a collection of permanent magnets were carefully positioned using 3D-printed parts. In \fig{fig:dis-setup-03}, it can be seen how the parts come together for Setup-3. The parts were printed on a LulzBot Taz 6. The material used was black ABS filament. \\

% Setup-1 was optimized for a Keplerian magnetic field, where $B_z \propto r^{-3/2}$. In fact, this is not the field needed to create a Keplerian flow, but it was the result of a derivation mistake we originally did not catch; we are still presenting this because it allows us to test our magnetic field modeling. Originally, \eqn{eqn:B-gen-prop} was mistakenly derived to $B_z (r) = \frac{2 \pi z A_k}{A_p I} \Omega$, with the $r^2$ factor missing. 

%There is a reason we jumped from numbering ``1'' to numbering ``3'' in naming the setups. After realizing that Setup-1 is not creating a Keplerian fluid flow in our lab, we made another magnet arrangement. We used a tool we wrote in Python (see \sect{section:mtd:fld-strength} for details on this tool) to optimize an arrangement of 15 rings of magnets, and we called this arrangement \textit{Setup-2}. However, we did not build it because that was too many rings, containing too many magnets, and the ring arrangement was too complicated. Instead, we used the same tool to optimize yet another arrangement with only ten rings of magnets. We called this new one \textit{Setup-3}. \\



% Used to have magnet radii test picture here. 

Setup-3 was a little more efficient than Setup-1 with the amount of work and building materials used to make it. Making Setup-1's rings in \fig{img:test-magnet-ring} keeps the magnets in place, but it also adds to the bulk of the magnet rings - it makes them take up too much space. They take up so much space that a smooth field profile is only possible at weak magnetic fields, such as the \SI{60}{gauss} that we used as the maximum for Setup-1. That is, when the magnets are far away from the water, their individual contributions are small, so at the water's surface the field is smooth. The discreteness of the magnets is not as apparent from the field when the magnets are that far. At the same time, the $A_k$ constant's value is small as well in that case - the overall flow has to be very slow. Our N42 magnets could do much better than that. Instead of these removable rings, Setup-3 was crafted such that the magnets were reversibly \textit{stuck} in the magnet tray, which was our mechanism for preventing the magnets from jumping out on their own. As discussed in \appx{ch:m-slot-r}, \SI{3.31}{mm} holes provided a sufficiently tight fit to hold the magnets in. \\

%\begin{figure}[!ht] 
%	\begin{subfigure}[b]{.7\textwidth} 
%		\begin{center} 
%			\includegraphics[width=.9\linewidth]{Figures/Renders-01/setup-03-b-parts-top-view.png} 
%		\end{center} 
%		\caption{ Top view. \label{fig:setup-03-top-view} } 
%	\end{subfigure} 
%	\begin{subfigure}[b]{.2\textwidth} 
%		\begin{center} 
%			\includegraphics[width=.9\linewidth]{Figures/Screens-01/Cylinder-Thing-v1.png} 
%		\end{center} 
%		\caption{ Centering cylinder. \label{scr:cylinder-thing-v1} } 
%	\end{subfigure} 
%	\caption{ The parts for Setup-3 have a centering mechanism. The center hole in each piece has radius \SI{18}{mm}, so all the pieces can be centered by merely inserting the cylinder of radius \SI{17.5}{mm} through the center when all the pieces are placed on top of each other as in \fig{fig:dis-setup-03}.  \label{fig:parts-and-cylinder-centering} } 
%\end{figure} 

% The magnet tray was designed with a magnet slot radius just small enough for the magnets to barely fit and become stuck. This radius was found to be \SI{3.31}{mm}, as explained in \appx{ch:m-slot-r}. Even though they are stuck, the magnet tray design allows us to take magnets out easily; the structural feature for that will be discussed shortly. \\

\begin{figure}[!ht] 
	\begin{subfigure}[b]{.6\textwidth} 
		\begin{center} 
			\includegraphics[width=.9\linewidth]{Figures/April-5/Inner-Electrode-Clamp.png} 
		\end{center} 
		\caption{ Inner electrode alligator clip \label{img:apr5:inner-electrode-clamp} } 
	\end{subfigure} 
	\begin{subfigure}[b]{.3\textwidth} 
		\begin{center} 
			\includegraphics[width=.9\linewidth]{Figures/April-5/Wire-Running-Under-Setup-3.png} 
		\end{center} 
		\caption{ Alligator clip's wire \label{img:apr5:wire-running-under-setup-3} } 
	\end{subfigure} 
	\caption{ The alligator clip wire goes under the setup, through the cylinder, and onto the electrode. \label{fig:apr5:alligator-clip-wire} } 
\end{figure} 

%There was a centering mechanism, as partly seen from \fig{fig:parts-and-cylinder-centering}. Each part in Setup-3 was made such that its inner radius is \SI{18}{mm}, a length that was arbitrarily chosen. See \fig{fig:setup-03-top-view}. As the centering mechanism, a cylinder of a minimally-sufficient height of \SI{60}{mm} was modeled and printed, the design for which is shown in \fig{scr:cylinder-thing-v1}. 3D-printed parts are difficult to fit into each other, so its radius was set to just under the parts that it centers, being \SI{17.5}{mm}. A notch was created in the center cylinder so that a wire can be run through it without obstructing the camera's view. See \fig{fig:apr5:alligator-clip-wire}. \\

There was a centering mechanism, as partly seen from \fig{fig:dis-setup-03}. Each part in Setup-3 was made such that its inner radius is \SI{18}{mm}. As the centering mechanism, a cylinder with a height of \SI{60}{mm} was printed. 3D-printed parts are difficult to fit into each other, so its radius was set to just under the parts that it centers, being \SI{17.5}{mm}. A notch was created in the center cylinder so that a wire can be run through it without obstructing the camera's view as shown in \fig{fig:apr5:alligator-clip-wire}. \\

Secondly, the tray at the top should be noted. It holds our electrolyte solution. The electrodes lined the inner and outer wall of the water tray, and the electrodes were connected to the power supply using alligator clips. A camera was situated above the water tray. One problem considered was that these alligator clips, being attached to the electrodes, could obstruct some of the camera's view of the water. In order to prevent this obstruction, the tray's inner and outer walls had windows in them for specially-cut pieces of the copper electrodes to stick out of. As a result, the alligator clips could be attached from the very inside of the inner cylinder and the very outside of the outer cylinder; they did not interfere with the camera's view of the water, as seen in \fig{img:apr5:inner-electrode-clamp}. \\

%When modeling, a boolean subtract was done on the centering cylinder using a cuboid. When printed and assembled, the hollow that the cuboid subtract created could be useful because an alligator clip wire could be run from underneath the magnet tray, as in \fig{img:apr5:wire-running-under-setup-3}, through this hollow, and to the inner electrode, as shown in \fig{img:apr5:inner-electrode-clamp}. This way the alligator clip wires did not have to run above the water and obstruct the camera's view. For the same purpose, the part at the bottom of \fig{fig:dis-setup-03} and to the right in \fig{fig:setup-03-top-view} was printed because the magnet tray is a big block that does not have space for the wire to run through. The wire must be run below the magnet tray to connect to the inner electrode, but that bottom printed part holds the tray up and level so that the wire can do that. \\

\begin{figure}[!ht] 
	\begin{subfigure}[b]{.5\textwidth} 
		\begin{center} 
			\includegraphics[width=.9\linewidth]{Figures/May-10/setup-03-magnet-tray-cross-section-colored-1.png} 
		\end{center} 
		\caption{ Whole tray \label{fig:setup-03-cross-section:whole} } 
	\end{subfigure} 
	\begin{subfigure}[b]{.5\textwidth} 
		\begin{center} 
			\includegraphics[width=.9\linewidth]{Figures/Renders-01/setup-03-magnet-tray-cross-section-2.png} 
		\end{center} 
		\caption{ Zoomed on the right side \label{fig:setup-03-cross-section:zoomed} } 
	\end{subfigure} 
	\caption{ Setup-3 magnet tray cross section. The magnets are inserted by pushing down on them from the top, and they do not stick out on the top when pushed all the way in. To take them out, the ``rescue holes'' can be used to push them out with a thin rod. The rescue holes go all the way to the bottom of the magnet tray. \label{fig:setup-03-cross-section} } 
\end{figure} 

% Since the magnets were to be fit as tightly as possible, to prevent them jumping out, the magnet slots were made to be of the bare-minimum radius discussed above and to be of just the right height to completely encapsulate a whole magnet. There were 10 rings of magnets in Setup-3. \\ 

% After measuring our magnets a few times using a digital caliper, we decided that \SI{6.31}{mm} was the best estimate of the magnets' heights. Although Setup-3 was different from Setup-1, the magnets were still organized in rings; they were just not separate rings printed and assembled together but rather one printed part with ten rings. Rings 1 through 9 all were close to the water sitting at the top, while ring 10 was a deeper ring sitting below the other rings. Its radius was between the radii of rings 6 and 7. \\

%When inserting magnets into the rings, first ring 10 was filled with magnets, north (N) up; access to this ring 10 is restricted by any magnets sitting in rings 6 and 7. Ring 10 had 48 magnets, and, to prevent these magnets from sliding vertically within the slot, 48 spacers were printed to fit on top of these magnets and hold them in place. In order to find the appropriate height for these spacers, the height differences between ring 10 and rings 6 and 7 were taken into account. Ring 10 was \SI{9.7}{mm} below ring 6, and \SI{10.4}{mm} below ring 7. The spacer needed to itself fit between the rings, so its height was chosen to be the lesser \SI{9.7}{mm} minus the height of one magnet, \SI{6.31}{mm}, minus a half a millimeter (\SI{0.5}{mm}) to account for printing imperfections. Namely, the 3D printer left a little notch at the top of each spacer because that is how the extruder works; as a result, the spacers needed to be just a little bit smaller in order to fit perfectly. Thus, the spacers were modeled to be \SI{2.9}{mm} in height. Their radius was \SI{3}{mm}, also to fit. After that, the rest of the rings were filled with magnets. For Setup-3, all rings except ring 1 were filled with north (N) up. Ring 1 was south (S) up. See the next section for the reasons. For Setup-1, all rings were north (N) up. \\

The magnet tray itself was all one big part in Setup-3, as seen in \fig{fig:setup-03-cross-section}. See \appx{ch:our-params} for details on the magnet arrangement. An important structural feature of the magnet tray was the \textit{rescue holes}. These are holes that connect the bottom of the magnet slots to the bottom of the magnet tray. These rescue holes can be seen as the thin tunnels in \fig{fig:setup-03-cross-section}. The holes have a radius of \SI{1.5}{mm}, just about half a magnet radius. When it is time to take the magnets out, a thin rod can be poked into these holes to force the magnets to come out. Thus, these holes allow us to help magnets that are stuck. \\

% The rings for Setup-1 also had these holes. \\

%Such were the 3D-printed parts and how they were assembled. Aside from the modeling differences between the two setups, they had the bare-bones' essentials in common: magnets arranged in a certain number of rings (6 for Setup-1, 10 for Setup-3), with each ring having a certain radius and being situated at a certain vertical position (referred to as \textit{height}) below the water. Plus, some of the rings were rotated to make the magnetic field profile a little bit smoother. In addition to that, the magnets' orientation must also be decided: will all magnets be north (N) up, or will some have south (S) as up, as in Setup-3? These were the parameters that needed adjustment in order to create our desired field profile. However, what parameters will create a Keplerian profile for Setup-1 and a square-root profile for Setup-3? The next section addresses this very question. \\

%As shown in \fig{fig:dis-setup-01}, the experimental setup consisted of different 3D-printed parts, the details of which will follow in a later section. For now, it is simply noted that the magnets are arranged in concentric rings at different heights below the water level, and with different radii, and different rotations (how much to rotate each ring about the z-axis). Having this setup in mind, we created Python code that optimized these parameters: heights, radii, and rotations. For the first part of the experiment, we had the code optimize for a Keplerian magnetic field. For the second part, we will have the code use equation \eqn{eqn:B-k-prop} to optimize for a Keplerian fluid flow profile. \\

















\section{ Magnetic Field \label{section:mtd:fld-strength} } 

The magnetic field due to many magnets is not trivial to find analytically and calculate by hand. However, by making a simplifying assumption of the magnets behaving like point dipoles, we were able to obtain results accurate enough to work for our experiment. The magnetic field due to a point dipole is defined as 

\begin{subequations} 
\label{eqn:B_xyz} 
\begin{equation} 
B_x = 3 M x z / r^5 , 
\end{equation} 
\begin{equation} 
B_y = 3 M y z / r^5 , 
\end{equation} 
\begin{equation} 
B_z = M \left( 3 z^2 - r^2 \right) / r^5 , 
\end{equation} 
\end{subequations} 

\noindent where $x$, $y$, and $z$ are cartesian coordinates, $r$ is the distance from the origin, and the magnetic dipole is oriented up and positioned at the origin \cite{NASA_DipoleEqn}. \appx{ch:dipole-M} reports our magnetization constant $M$. Using \eqn{eqn:B_xyz}, we could calculate the approximate magnetic field due to a single magnet. We wanted to arrange magnets in rings, so we had to write Python code that took ring parameters rather than magnet parameters. The code summed over the magnetic field contributions from each magnet within each ring of magnets, and it obtained a grid of $x$, $y$, and $z$ Cartesian components to the net magnetic field. This way we were able to plot predicted magnetic fields before actually building each setup. For the complete Python code, see the download link in \appx{ch:user-optimize}. \\










%, as we discuss below. \\

% Because \texttt{minimize ()} can handle only one vector, and not three, but we had three parameters to optimize for each ring - the radius, height, and rotation - we had to put the vectors for all three quantities into just one vector. We called this vector the \textit{state vector}.









\begin{figure}[!ht] 
	\begin{center} 
		\includegraphics[width=3in]{Figures/April-5/SAM_4714.png} 
	\end{center} 
	\caption{ We measured the magnetic field at different distances from the center for Setup-3 using a gaussmeter and a few tools that we custom 3D-printed for positioning the magnetic field probe accurately. \label{img:meas-b-3} } 
\end{figure} 

After building Setup-3, we wanted to know if the magnetic field physically present in our system matched the magnetic field we predicted. To measure the magnetic field, we needed a mechanism of positioning the probe. First, we 3D-printed the three-legged piece shown in \fig{img:meas-b-3}. Its center also has a hole with a radius of \SI{18}{mm}, so the centering is consistent. Each leg has a pocket in the shape of our gauss meter probe, \SI{6}{mm} wide and \SI{2}{mm} deep. The pocket was designed such that its bottom surface matched our target water level. The gaussmeter probe was placed in this pocket. \\

% Unlike Setup-1, our Setup-3 had a centering mechanism, and, although the printed magnet tray was a little warped, its dimensions were a lot more reliable than what we were able to obtain for Setup-1. 

\begin{figure}[!ht] 
	\begin{center} 
		\includegraphics[width=6in]{Figures/May-12/Plots/Setup-3/vertical-magnetic-field-slice.png} 
	\end{center} 
	\caption{ The black curve is the theoretically predicted magnetic field profile for the Setup-3 magnet arrangement. Orange is a fit to show that it is roughly square-root shaped, and green dots are measurements using a gaussmeter. \label{plot:may12:setup-3-field-profile} } 
\end{figure} 

The next task was to find a mechanism for accurately positioning the probe radially, as the probe was able to slide radially inside the pocket. We designed and printed spacers of width \SI{6}{mm} and of varying lengths, which came in \SI{2.5}{mm}, \SI{5.0}{mm}, \SI{10.0}{mm}, \SI{20.0}{mm}, \SI{40.0}{mm}, and \SI{50.0}{mm}. To position the probe at any given radial position, we placed spacers, the sum of the lengths of which adds up to that radial position minus \SI{18}{mm}, against the centering cylinder. We then placed the gauss meter probe against these spacers, and held it down flat against the floor of our probe track. The measurements were obtained and plotted in \fig{plot:may12:setup-3-field-profile}. For some reason, the $M$ constant needed to be scaled down by 80\% in order to make the theoretical prediction fit the measured profile. \\


% we wanted to make sure that the magnetic field actually in the physical setup matched the design field. We borrowed a gauss meter from the Kleinert Lab and measured the magnetic field at various distances from the center of the setup. See \fig{img:meas-b-1}. Setup-1 did not print out fine: it printed to be a little bit slanted. Plus, we were using a caliper to measure approximate radial positions of the gauss meter's probe. As a result of both of these, the $B_z$ data for Setup-1 had millimeters of uncertainty. Nevertheless, the results were still informative. \\






% plot:cyl-b-1:z 
% plot:cyl-b-1:z 













% In order to address these issues, we set out to build another Python tool to optimize the magnet arrangement. We used the Bokeh interactive plot library, and the user interface controls are shown in \fig{scr:apr5:bokeh-iface}. This time we wanted the tool to rely on user input because the user has much more knowledge about the desired physical setup and will not arrange for non-physical parameters as the computer would. We optimized the parameters by hand using our tool, and, after building the magnet tray, the magnetic field looked correct except that it was 75\% weaker than predicted. \\

%We thought about what would be the best form of user input, and we searched online for libraries that allow for interactive plots in Python. A library called \textit{Bokeh} seemed attractive because it can be used to create sliders. All the user would have to do is slide a slider and watch the graph change. We installed Bokeh on the Borrero Lab computer and built the interface shown in \fig{scr:apr5:bokeh-iface}. The sliders on the left control the height of each magnet ring below the XY-plane, and the sliders on the right control the radius of each ring. There is currently no way to adjust the rotation angles from the user interface, as of the time of this writing, so that must be adjusted manually in the text file that the Python code saves to. The ``Water Z'' slider controls how high the water level is above the XY-plane, default being 0. This slider was created because we needed to see how a mistake in the water level height can affect the magnetic field profile at the water's surface. 















%The ``Magnet M'' slider controls how much to scale the magnets' magnetization constant by before calculating the predicted magnetic field to put in the plot. For example, see \fig{scr:apr5:bokeh-plot}, which shows the feedback part of the user-optimize Python tool we developed to assist us in optimizing for the magnet arrangement in Setup-3. As such, it does not label the axes or provide a legend because we are its operators, and we know what all the components of the plot are. We have separate tools to generate plots for publication. In the plot, however, the purple dots represent our physical measurements of what the magnetic field actually was. These were not there when we were designing the magnet arrangement; they appear only after we build the setup and take and record measurements of the magnetic field. When we built the setup, the physically-measured magnetic field was, for the most part, only about 75\% of the predicted field, so we set the $M$ to be 75\% of the original $M$ for that plot for Setup-3. The two sliders, ``Water Z'' and ``Magnet M'', are there mainly for checking to make sure the water is positioned correctly vertically and the magnetization constant $M$ is calculated correctly. The $M$ is likely calculated correctly, but the 3D print of the Setup-3 magnet tray became warped - a problem our 3D printer has been having - which may be what is contributing to the observed inconsistency of the measured field profile compared to the predicted. \\

% Nevertheless, the field still looks very square-root-shaped in the radial position range from around \SI{50}{mm} to almost \SI{80}{mm}. We know that because of the thick blue template lines. The templates are just square-root curves scaled up to fit the data, for the purple dots, and the predicted curve, for the green curve. There are both components in this plot, so there are two template curves in the background. These template curves are meant mainly for the optimization part of the workflow. When dragging the sliders to move magnet rings around, the user tries to make the green curve match the thick blue template behind it. The default template is $\propto r^{0.5}$ (square-root), but that can be changed by changing one or both of the text inputs that say ``Power'' and ``0.5'', seen in \fig{scr:apr5:bokeh-iface}. The ``0.5'' means to shape the template as $r^{0.5}$; ``1.5'' would have made $r^{1.5}$, and so on. As seen here, the template curve is useful for finding the optimal magnet arrangement. \\

% There are two text inputs because sometimes we would like to compare a profile to two powers of $r$ at the same time; if the two text inputs are set to different values, the Python code will draw two different template curves. This can be useful, but it also becomes confusing, so we leave both inputs as the same value for the most part. As seen here, the template curve is useful for finding the optimal magnet arrangement. \\

% One other important part of the user-optimize tool is the physical magnet arrangement plotted at the bottom, also seen in \fig{scr:apr5:bokeh-plot}. The code plots magnets as light-pink rectangles, the water surface as a thin, horizontal, blue line, and the floor of the water cell as the horizontal black line underneath that. These are as important as the template curves because without them, the user cannot see if they are spacing magnets apart enough, or if the magnets are close to overlapping in space. \\





%\begin{figure}[h] 
%	\begin{center} 
%		\includegraphics[width=6in]{Figures/April-6/Setup-3-Optimized/vertical-magnetic-field-slice.png} 
%	\end{center} 
%	\caption{ The predicted vertical component, $B_z$, magnetic field profile as a function of radial position for Setup-3 that we were able to optimize our magnet arrangement to using our Python Bokeh tool. \label{plot:prof-b-3-opt} } 
%\end{figure} 
%
%Using this Python tool, we tried hard to make a smooth square-root curve, and we came up with a magnet arrangement that resulted in the predicted magnetic field profile shown in \fig{plot:prof-b-3-opt}. We were unable to make a feasible magnet arrangement that covered the full range from \SI{30}{mm} to \SI{90}{mm} with a square-root field profile, so we compromised so that the magnetic field profile was proportional to $r^{1/2}$ for radial positions \SI{40}{mm} - \SI{80}{mm} from the center. Thus, we had acquired the parameters for a magnet arrangement that leads to a Keplerian fluid flow, so we could study the fluid flow. \\






% Our digital caliper was borrowed from the Borrero Lab, and a caliper cannot be used very effectively for the task anyway, so we designed and printed spacers of width \SI{6}{mm} and of varying lengths, which came in \SI{2.5}{mm}, \SI{5.0}{mm}, \SI{10.0}{mm}, \SI{20.0}{mm}, \SI{40.0}{mm}, and \SI{50.0}{mm}. To position the probe at any given radial position, we parked spacers, the sum of the lengths of which adds up to that radial position minus \SI{18}{mm}, against the centering cylinder. We then parked the gauss meter probe against these spacers, and held it down flat against the floor of our probe track. Again, see \fig{img:meas-b-3}. \\

%\begin{figure}[h] 
%	\begin{center} 
%		\includegraphics[width=6in]{Figures/April-5/Plots/Setup-03-b/vertical-magnetic-field-slice.png} 
%	\end{center} 
%	\caption{ The vertical component, $B_z$, magnetic field profile as a function of radial position for Setup-3. \label{plot:prof-b-3} } 
%\end{figure} 

% We obtained the measurements shown as dots in \fig{plot:prof-b-3}. 

% We obtained the measurements shown as dots in \fig{scr:apr5:bokeh-plot}. At first, the green curve representing the predicted average magnetic field was higher than the actual measured samples. Setting the ``M Scale'' slider to 0.75, i.e., scaling down the predicted field by 75\%, gave us the black curve shown in the plot in \fig{plot:prof-b-3}. Probably, the warping of the 3D-printed magnet tray has caused the magnetic field profile to be off the predicted. Nevertheless, the profile is still roughly square-root in the range \SI{50}{mm} to around \SI{75}{mm}, which is satisfying because it means the fluid flow can still be nearly Keplerian in that range, despite the 3D-printed part warping. The radial, azimuthal, and $z$ components of the magnetic field at the surface of the water can be seen in \fig{fig:cyl-b-3}. The discreteness is still visible a little bit due to the individual magnets, but it is still smooth for the most part. \\

%\begin{figure}[h] 
%	\begin{subfigure}[b]{0.3\textwidth} 
%		\begin{center} 
%			\includegraphics[width=\linewidth]{Figures/April-5/Plots/Setup-03-b/Br.png} 
%		\end{center} 
%		\caption{ Radial, $B_r$ \label{plot:cyl-b-3:r} } 
%	\end{subfigure} 
%	\begin{subfigure}[b]{0.3\textwidth} 
%		\begin{center} 
%			\includegraphics[width=\linewidth]{Figures/April-5/Plots/Setup-03-b/Bt.png} 
%		\end{center} 
%		\caption{ Azimuthal, $B_t$ \label{plot:cyl-b-3:t} } 
%	\end{subfigure} 
%	\begin{subfigure}[b]{0.3\textwidth} 
%		\begin{center} 
%			\includegraphics[width=\linewidth]{Figures/April-5/Plots/Setup-03-b/Bz.png} 
%		\end{center} 
%		\caption{ Vertical, $B_z$ \label{plot:cyl-b-3:z} } 
%	\end{subfigure} 
%	\caption{ The radial, azimuthal, and vertical components of the predicted magnetic field, in gauss, in cylindrical coordinates for Setup-3. \label{fig:cyl-b-3} } 
%\end{figure} 

\begin{figure}[!ht] 
		\begin{subfigure}[b]{3in} 
			\begin{center} 
				\includegraphics[width=\linewidth]{Figures/May-12/Plots/Setup-3/Br.png} 
			\end{center} 
			\caption{ Radial, $B_r$ \label{plot:cyl-b-3:r} } 
		\end{subfigure} 
		\begin{subfigure}[b]{3in} 
			\begin{center} 
				\includegraphics[width=\linewidth]{Figures/May-12/Plots/Setup-3/Bt.png} 
			\end{center} 
			\caption{ Azimuthal, $B_t$ \label{plot:cyl-b-3:t} } 
		\end{subfigure} 
	\begin{center} 
		\begin{subfigure}[b]{3in} 
			\begin{center} 
				\includegraphics[width=\linewidth]{Figures/May-12/Plots/Setup-3/Bz.png} 
			\end{center} 
			\caption{ Vertical, $B_z$ \label{plot:cyl-b-3:z} } 
		\end{subfigure} 
	\end{center} 
	\caption{ The radial, azimuthal, and vertical components of the predicted magnetic field, in gauss, in cylindrical coordinates for Setup-3. \label{fig:cyl-b-3} } 
\end{figure} 

% To see how the magnetic field profile looks in 2D, we plotted the same 75\%-scaled-down predicted field using PyPlot's \texttt{pcolormesh ()} and \texttt{colorbar ()}, which gave us the profiles in \fig{fig:cyl-b-3}. The discreteness can be seen a little bit due to the individual magnets, but it is still smooth for the most part. \\

We have also plotted the predicted magnetic fields in \fig{fig:cyl-b-3}. They show that the magnetic field in the radial direction is small for the radial positions from \SI{50}{mm} to \SI{70}{mm}, and that in the azimuthal direction is negligible. The vertical component of the magnetic field is the most significant component. As seen in \fig{plot:may12:setup-3-field-profile} and \fig{fig:cyl-b-3}, we have successfully predicted the magnetic fields and designed magnet arrangements for the specific field profile, which was the point of this section. In the next sections, we describe how we went about driving the fluid flow and measuring it. \\










%\section{ The Parameters } 


% In the next section, we describe how we modeled these in FreeCAD and then how we 3D-printed them. \\



















\section{ Conducting the Experiment } 









%\section{ From 3D Models to Prints } 

%We had to choose a 3D CAD software for designing our models. We considered AudoDesk Fusion 360, OnShape, Blender, and FreeCAD. Fusion 360 and OnShape require sign-up and are web-based. Web-based software has the limit of how fast the browser can run it, but we wanted software that would run natively on the operating system and not be slowed by browser and JavaScript limits. Blender is such a software that runs natively, but it offers essentially no ability to change objects' dimensions once they are created. We still used Blender for assembling artistic drawings, such as the ones in \fig{fig:both-setups-side-by-side}, but, for technical drawings, FreeCAD was left. \\

%FreeCAD has a nice little user interface, shown in \fig{scr:apr6:FreeCAD-part-view}. Near the top-right there is a drop-down menu, where it says ``Part.'' This drop-down menu is called the workbench selection; each stage of a project would use a different workbench. We have only used the ``Spreadsheet,'' ``Part Design,'' and ``Part'' workbenches for our designs. 

% We used FreeCAD to design our models; its interface is shown in \fig{scr:apr6:FreeCAD-part-view}. In the \textit{spreadsheet} workbench, we would make spreadsheets with the parameters required for the design, and then we would sketch and pad (``extrude'') our sketches in the part design workbench. For the more advanced parts, we would make multiple sub-parts, and then use the boolean tool (two blue balls at the very top-right of the toolbar) to subtract one object from another. \\

%FreeCAD is still under development - the latest version is 0.16, as of this writing - but it suits our design needs. \\

%\begin{figure}[h] 
%	\begin{center} 
%		\includegraphics[width=6in]{Figures/April-6/Setup1-Rings34.png} 
%	\end{center} 
%	\caption{ Setup-1 rings 3 and 4 combined in Blender and printed as a single part. \label{scr:apr6:setup1-rings34} } 
%\end{figure} 

% We designed the parts using some of the considerations already discussed in \sect{section:mtd:target-setup}. For both setups, we made each ring separately. For Setup-1, we made each ring using the template in \fig{img:test-magnet-ring}, and we printed each ring separately. Because of the parameters from \tbl{tbl:setup-1-params}, rings 3 and 4 had to go inside each other, but they did not fit inside each other. Thus, we put the two rings together into one model in Blender, raised ring 3 to the height that \tbl{tbl:setup-1-params} dictates relative to ring 4, and printed it as one part. This model is shown in \fig{scr:apr6:setup1-rings34}. \\

% Next, we modeled and printed a magnet tray for Setup-1; the magnet tray had circle-shaped ring holders on it - see \fig{img:exp-01-magnet-tray-printed}. The part with rings 3 and 4, shown in \fig{scr:apr6:setup1-rings34} did not fit onto the ring holders, so we had to trim that part down before fitting it there. Our lab did not have sand paper for plastic, or other similar tools, but the thick metal shears used for cutting the copper shim stock worked fine. We fixed the part in the vise and cut away at the inside of it, rotating the part every few cuts. It made a mess, but it finally fit. Another lesson from Setup-1 was not to place magnet rings too close to each other. \\

% For Setup-1, rings 3 and 4 were so close together that they had to be combined and printed as one part, \fig{scr:apr6:setup1-rings34}. 

% Despite the coarse print resolution of \SI{0.5}{mm} at the finest setting, we still copied the numbers from the parameter CSV file without rounding, pasting straight into the FreeCAD spreadsheet; this was done in order for us to have no doubt that we did all we could to make an accurate design. \\

After we printed the parts shown in \fig{fig:dis-setup-03} and inserted magnets in the appropriate orientations into the slots, we made electrodes for the water cell. We cut out copper shim stock to have a width of approximately \SI{1}{cm}, and we made its length be enough to fit around the wall they are lining. The result is shown in \fig{img:apr5:setup-3-sys}. \\

\begin{figure}[!ht] 
	\begin{center} 
		\includegraphics[width=4in]{Figures/April-5/SAM_4717.png} 
	\end{center} 
	\caption{ The Setup-3 system: a magnet tray, with a cylindrical water tray sitting on top of it. \label{img:apr5:setup-3-sys} } 
\end{figure} 



To record a 2D fluid flow, we needed to put the setup together. We used \SI{113.1}{mL} of \SI{1.0}{M} \ch{CuSO4 * 5 H2O} (one molar copper sulfate pentahydrate) as an electrolyte. We seeded the solution with cospheric glass bubbles. \\

\begin{figure}[!ht] 
	\begin{center} 
		\includegraphics[width=6in]{Figures/April-5/Setup-Look-Front.png} 
	\end{center} 
	\caption{ Experimental setup. There is an IDS uEye camera fixed above the system, a grid of LED lights fixed next to it, a current driver hooked up to the system, and an ammeter to monitor the current accurately. \label{img:apr5:setup-look-front} } 
\end{figure} 

The experimental setup is shown in \fig{img:apr5:setup-look-front}. We connected a DC power supply to the electrodes and drove a current through the system. We measured the current with an ammeter, which had three decimal places of precision. \\

% The uEye camera at the top recorded the flow at the water surface. See \appx{ch:take-data} for details on recording video. \\

% We made a \SI{1.0}{M} solution of copper sulfate pentahydrate, \ch{CuSO4 . 5 H2O}, and we poured it into the water cell. To make a water layer of \SI{5}{mm}, we calculated that we need $\pi \left( \left( \SI{9}{cm} \right)^2 - \left( \SI{3}{cm} \right)^2 \right) \left( \SI{0.5}{cm} \right)$ as the volume of electrolyte to put into the cell, which evaluates to just about \SI{113.1}{mL}, converting $\si{cm}^3$ to \si{mL}. After filling the water cell with \SI{113.1}{mL} of our copper sulfate solution, we used the current-driving feature of our power supply to drive an electric current through the electrodes. We measured the current with the amp meter, which had three decimal places of accuracy. \\



% For Setup-3 it was simpler because we did not have to print many different rings. 


% In the next section, we describe how we put together all these parts with the camera and lights for recording to the computer. \\












%\section{ Putting It All Together \label{section:mtd:put-together} } 

%This part of the experimental setup was the same for both Setup-1 and Setup-3. For Setup-1, the system in \fig{fig:exp-01-top-view} was placed under the camera. For Setup-3, the system in \fig{img:apr5:setup-3-sys} was placed under the camera. \\



%\begin{figure}[h] 
%	\begin{subfigure}[b]{.4\textwidth} 
%		\begin{center} 
%			\includegraphics[width=.9\linewidth]{Figures/April-5/Camera-Clamp.png} 
%		\end{center} 
%		\caption{ Camera \label{img:apr5:clamps:camera} } 
%	\end{subfigure} 
%	\begin{subfigure}[b]{.6\textwidth} 
%		\begin{center} 
%			\includegraphics[width=.9\linewidth]{Figures/April-5/Light-Clamp.png} 
%		\end{center} 
%		\caption{ LED Light \label{img:apr5:clamps:camera} } 
%	\end{subfigure} 
%	\caption{ We clamped the camera and the light using posts and clamp holders. \label{img:apr5:clamp} } 
%\end{figure} 

% We fixed the camera and light as shown in \fig{img:apr5:clamp}. The camera was connected to our lab's corner computer for image sequence capture. \\











\section{ Setup-1 as a Test } 

While Setup-3 was our primary experimental apparatus, it was not the first one we built. First, we built \textit{Setup-1}, which was a prototype as well as a test to make sure \eqn{eqn:B-gen-prop} works. We chose to build Setup-1 with a field profile $\propto r^{-1.5}$. An assembly drawing is shown in \fig{fig:dis-setup-01}. \\

\begin{figure}[!ht] 
	\begin{center} 
		\raisebox{-.5\height}{\includegraphics[width=3in]{Figures/Renders-01/setup01-part-cell.png}} 
		\raisebox{-.5\height}{\includegraphics[width=3in]{Figures/Renders-01/setup01-part-support.png}} 
		\raisebox{-.5\height}{\includegraphics[width=3.5in]{Figures/Renders-01/setup01-part-magnet-tray-no-bg.png}} 
	\end{center} 
	\caption{ An assembly drawing of Setup-1. The magnet tray is a complex part with removeable rings of magnets. The water cell sits at the top as usual. \label{fig:dis-setup-01} } 
\end{figure} 

\begin{figure}[!ht] 
	\begin{center} 
		\includegraphics[width=.75\linewidth]{Figures/Photos-01/IMAG2668.jpg} 
	\end{center} 
	\caption{ A test magnet ring with cylindrical slots for five magnets. The ring also has flat slots for copper shim stock to go through and hold the magnets in place. In case the magnets get stuck, there are small holes on the opposite side for pushing the magnets out with a thin tool. The magnets were inserted with the north (N) pole directed vertically \textit{up}. \label{img:test-magnet-ring} } 
\end{figure} 

Setup-1 was built with the thought in mind that magnets tend to align themselves anti-parallel to the magnetic field in their environment. Strong magnets will force themselves out of any magnet-holding slots that do not hold them in place tightly enough. Thus, in fear of the slots not being tight enough, we 3D-printed special rings that had not only magnet slots but also shim-stock slots for holding the magnets in the magnet slots, and we secured the magnets using specially-cut copper shim stock bars into these 3D-printed rings as shown in \fig{img:test-magnet-ring}. Like Setup-3, rings in Setup-1 also had rescue holes. The rings were placed onto special stands for them in the bottom part of \fig{fig:dis-setup-01}, and the setup was assembled as shown in \fig{fig:exp-01-top-view}. \\

\begin{figure}[!ht] 
	\begin{center} 
		\begin{subfigure}[b]{0.3\textwidth} 
			\includegraphics[width=\linewidth]{Figures/Photos-01/Magnet-Tray-From-Top-1.png} 
			\caption{ Magnets uncovered. \label{img:exp-01-top-view:uncov} } 
		\end{subfigure} 
		\begin{subfigure}[b]{0.3\textwidth} 
			\includegraphics[width=\linewidth]{Figures/Photos-01/Magnet-Tray-From-Top-2.png} 
			\caption{ Magnets covered. \label{img:exp-01-top-view:cov} } 
		\end{subfigure} 
		\begin{subfigure}[b]{0.3\textwidth} 
			\includegraphics[width=\linewidth]{Figures/Photos-01/System-From-Top.png} 
			\caption{ Water cell on top. \label{img:exp-01-top-view:w-cell} } 
		\end{subfigure} 
	\end{center} 
	\caption{ Top-down view photos of the system. The magnets are inside the rings where the copper shim stock pieces are; the shim stock pieces are for holding the rings in place, as well as for preventing any magnets from jumping out. \label{fig:exp-01-top-view} } 
\end{figure} 

\begin{figure}[!ht] 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/Photos-01/System-Perspective-1.png} 
		\caption{ Top-front perspective. \label{img:exp-01-persp-view:1} } 
	\end{subfigure} 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/Photos-01/System-Perspective-2.png} 
		\caption{ Front perspective. \label{img:exp-01-persp-view:2} } 
	\end{subfigure} 
	\caption{ Perspective-view photos of the system. \label{fig:exp-01-persp-view} } 
\end{figure} 


% Secondly, the tray at the top should be noted. It holds our electrolyte solution. The electrodes lined the inner and outer wall of the water tray, and the electrodes were connected to the power supply using alligator clips. A camera was situated above the water tray. One problem considered was that these alligator clips, being attached to the electrodes, could obstruct some of the camera's view of the water. In order to prevent this obstruction, the tray's inner and outer walls had windows in them for specially-cut pieces of the copper electrodes to stick out of, as seen in \fig{fig:exp-01-persp-view}. As a result, the alligator clips could be attached from the very inside of the inner cylinder and the very outside of the outer cylinder; they did not interfere with the camera's view of the water to image the flow. \\



\begin{figure}[!ht] 
	\begin{subfigure}[b]{3in} 
		\begin{center} 
			\includegraphics[width=\linewidth]{Figures/May-12/Plots/Setup-1/Br.png} 
		\end{center} 
		\caption{ Radial, $B_r$ \label{plot:cyl-b-1:r} } 
	\end{subfigure} 
	\begin{subfigure}[b]{3in} 
		\begin{center} 
			\includegraphics[width=\linewidth]{Figures/May-12/Plots/Setup-1/Bt.png} 
		\end{center} 
		\caption{ Azimuthal, $B_t$ \label{plot:cyl-b-1:t} } 
	\end{subfigure} 
	\begin{center} 
		\begin{subfigure}[b]{3in} 
			\begin{center} 
				\includegraphics[width=\linewidth]{Figures/May-12/Plots/Setup-1/Bz.png} 
			\end{center} 
			\caption{ Vertical, $B_z$ \label{plot:cyl-b-1:z} } 
		\end{subfigure} 
	\end{center} 
	\caption{ The radial, azimuthal, and vertical components of the predicted magnetic field, in gauss, in cylindrical coordinates for Setup-1. \label{fig:cyl-b-1} } 
\end{figure} 





% For Setup-1, we defined a function in Python that took a vector as an argument and returned a scalar. For a system with $N$ rings, the input vector consists of $3 N$ components: $N$ representing ring heights, followed by $N$ representing ring radii, finally followed by $N$ representing the angle, in radians, by which to rotate each of the rings about the Z-axis. We added this third parameter in order to be able to make the magnetic field profile smoother than if all rings started at angle $0 ^\circ$. The function that we fed to \texttt{minimize ()} took this state vector as an input and used the code discussed above to calculate a grid of magnetic field $B_z$ values. It only considered the values for the magnetic field at radial positions between \SI{30}{mm} and \SI{90}{mm} because that was the inner and outer radii of the water inside our water cell from \fig{fig:both-setups-side-by-side}. The function then calculated what the desired 2D $B_z$ profile should be and subtracted that from the calculated $B_z$ prediction that it also just found. This way, it had obtained a grid representing the difference between the target field and the provided parameters' resulting field. SciPy's \texttt{minimize ()} requires this function to return a scalar, so the function squared all the values of this difference grid, added them together, and took a square-root to obtain a scalar that it returned. Thus, larger deviations from the target magnetic field yielded larger scalar values returned. In this manner, SciPy's \texttt{minimize ()} returned a result state vector that fit the target quite well. \\




% Up until this point, whether Setup-1 or Setup-3 needed to be built was irrelevant: we built both setups using the same underlying magnetic field calculation code. However, the strategy employed to find the optimal magnet locations was different between the two setups. Setup-1 was easy: its magnetic field being so weak, we were able to have the magnets so far away from the water that at the water's surface, the magnetic field profile was almost a perfectly smooth Keplerian curve. The SciPy Optimize library looked attractive because it has a \texttt{minimize ()} function that can automatically minimize an arbitrary scalar function of a vector. The solution to use SciPy's \texttt{minimize ()} worked for Setup-1 but not for Setup-3. Thus, we built a user-operated optimization tool, and it is described in \appx{ch:user-optimize}. \\




% While the result state vector may not have been the global minimum, it yielded a quite accurate magnetic field profile. \fig{plot:cyl-b-1:z} shows the magnetic field, $B_z$, in the vertical direction for Setup-1, predicted using the $M$ and the code discussed above. The other plots in \fig{fig:cyl-b-1} were made by first calculating the $B_x$ and $B_y$, and then by taking the dot product of these components with the vectors $\hat{x}$ and $\hat{y}$ to find the radial and azimuthal components of the magnetic field. \\

While the resulting magnet arrangement for Setup-1 may not have been the global optimal arrangement, it yielded a quite accurate magnetic field profile. The predicted magnetic field for Setup-1 is shown in \fig{fig:cyl-b-1}. \fig{plot:cyl-b-1:z} shows the magnetic field, $B_z$, in the vertical direction for Setup-1, predicted using the $M$ and the code discussed above. \\

\begin{figure}[!ht] 
	\begin{center} 
		\includegraphics[width=3in]{Figures/April-5/Measuring-Setup-1-Bz.png} 
	\end{center} 
	\caption{ We measured the magnetic field at different distances from the center for Setup-1 using a caliper and a gauss meter. The gauss meter was carefully taped to a plastic piece of width \SI{4.5}{mm}, almost the \SI{5}{mm} for the water level, and placed on top of the water cell's floor for measuring. \label{img:meas-b-1} } 
\end{figure} 

After building Setup-1, \fig{fig:exp-01-persp-view}, we wanted to make sure that the magnetic field in the physical setup matched the design field. We borrowed a gaussmeter from the Kleinert lab and measured the magnetic field at various distances from the center of the setup (see \fig{img:meas-b-1}). The gaussmeter provided us with magnetic field data, but unfortunately it was difficult to position the probe accurately to measure the field profile. Setup-1 did not print out correctly: it printed to be a little bit slanted. Plus, we were using a caliper to measure approximate radial positions of the gauss meter's probe. As a result of both of these, the $B_z$ data for Setup-1 had millimeters of uncertainty. Nevertheless, the results were still informative. \\

\begin{figure}[!ht] 
	\begin{center} 
		\includegraphics[width=6in]{Figures/May-12/Plots/Setup-1/vertical-magnetic-field-slice.png} 
	\end{center} 
	\caption{ The vertical component, $B_z$, magnetic field profile as a function of radial position for Setup-1. The green dots are the measurement samples from the actual measurements done on the system we built, as measured by the method in \fig{img:meas-b-1}. The orange line is a $r^{-3/2}$ curve scaled to fit the green dots. \label{plot:prof-b-1} } 
\end{figure} 

Those results are plotted in \fig{plot:prof-b-1}. The black curve is the field profile predicted by the method above. It comes with error bars representing the standard deviation of the profile as the various azimuthal directions are sampled. For Setup-1, the magnetic field profile varies very little with change in azimuthal direction. We wanted to see that our actual magnetic field present was indeed Keplerian, and we saw from this plot that it was, within measurement error, at least until about \SI{85}{mm} or so from the center. \\

Despite the success of Setup-1, it had two major problems. First, it was made by a computer, namely by the \texttt{minimize ()} function. The code often returned non-physical results. For example, it would often overlap two magnet rings in space when requested to solve for a stronger magnetic field. And while not overlapping the magnets, it did not always solve for a state vector that caused a smooth profile. The target field we had it solve for had a maximum of \SI{60}{gauss} at position $r = \SI{30}{mm}$. However, setting this maximum even to \SI{70}{gauss} made the curve not quite fit the $r^{-3/2}$ Keplerian profile. The computer could only solve for a smooth and \textit{weak} field profile, and the problem with such a weak magnetic field was that we were not able to drive a very fast fluid flow, even when driving \SI{5.0}{A} of current through the electrodes. The second major problem with Setup-1, however, was that the magnetic field should have been a square-root profile to drive a Keplerian fluid flow, by \eqn{eqn:B-gen-prop}. We found the mistake after we ran the experiment and found that the angular velocity profile was actually $\propto r^{-7/2}$ rather than the desired $\propto r^{-3/2}$. That result was in agreement with \eqn{eqn:B-gen-prop}, of course, but it meant we had to build another setup. \\




\begin{figure}[!ht] 
	\begin{center} 
		\includegraphics[width=.75\linewidth]{Figures/Photos-01/IMAG2747.jpg} 
	\end{center} 
	\caption{ The bottom part: the magnet tray; some of the outer-most posts broke a little during printing, but it mostly turned out fine. \label{img:exp-01-magnet-tray-printed} } 
\end{figure} 

A large magnet ring holder tray was printed as shown in \fig{img:exp-01-magnet-tray-printed}. For the specifics of the models, see the FreeCAD files, but the main idea is that the magnets were positioned in exactly the positions that the Python code optimized to, and the water cell had enough space for a \SI{5}{mm} layer of water, with inner radius of \SI{30}{mm} and outer radius of \SI{90}{mm}. \\






























\section{ Taking and Processing Image Data \label{section:mtd:pre-process-data} } 

The next step was to record image data. We used a \texttt{USB 3 uEye CP Rev. 2} camera with a \texttt{HR F1.4/12 mm} objective. See \appx{ch:take-data} for details and instructions on recording video. For best results in particle image velocimetry (PIV), the image data needed to be pre-processed before being fed into the PIV algorithm. As the first step, we decided that background subtraction would help eliminate some misleading PIV cross-correlations. A common approach is to use the statistical mean frame as the background, but we decided on the statistical minimum instead in order to avoid negative pixel values, which for unsigned integers underflow and become 256 plus the negative value; the math becomes more complicated than we would like to deal with. Changing from unsigned integers to floating-point values for the pixels could be a possible solution, but, depending on the integer size, the integer approach can take less memory, so we left it as is but used the frame with all statistical minimum pixels instead. \\

\begin{figure}[!ht] 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-3/Setup-01/frame1-no-bg.png} 
		\caption{ Setup-1 \label{frame:apr3:s-1-ready} } 
	\end{subfigure} 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-3/Setup-03-b/frame1-no-bg.png} 
		\caption{ Setup-3 \label{frame:apr3:s-3-ready} } 
	\end{subfigure} 
	\caption{ The frames after subtracting the background and filling unimportant pixels with zeros. \label{frame:apr3:ready} } 
\end{figure} 

We subtracted the background, which was the minimum. However, slight lighting variations have caused the background to still faintly appear in this difference frame. We needed the background to not appear at all, so we found where the center pixel was in the frames of each image set, as well as how many pixels from that center the water starts and ends, and we set all the pixels outside of that range to zero. The result is shown in \fig{frame:apr3:ready}, which we fed to the PIV algorithm. \\












%\section{ Particle Image Velocimetry \label{section:mtd:piv} } 

The next task was to find a library for particle image velocimetry (PIV). As of the writing of this thesis, there were a few libraries for MATLAB, but only one easily-accessible library for Python, called OpenPIV. OpenPIV is also, as of this writing, not very developed yet, many features being not yet implemented; however, it works on Python - which is free and open source - and it has the most important functions developed already, such as velocimetry and validation. We settled on OpenPIV. \\

%\begin{figure}[h] 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-3/Setup-01/Plots/result-use-count.png} 
%		\caption{ Setup-1 \label{frame:apr3:s-1-use-count} } 
%	\end{subfigure} 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-3/Setup-03-b/Plots/result-use-count.png} 
%		\caption{ Setup-3 \label{frame:apr3:s-3-use-count} } 
%	\end{subfigure} 
%	\caption{ Validated use count field for the $(u, v)$ vectors averaged. \label{frame:apr3:use-count} } 
%\end{figure} 

The OpenPIV code was run, and its local median validation methods were invoked using $u$ and $v$ thresholds of $\SI{2}{mm/s}$ for the \texttt{validation.local\_median\_val ()} function. For each velocity sample, the local median method finds the median of the nearby velocities, and it takes a difference of this local median with the velocity sample under question. If the difference is greater than the specified threshold, then the velocity sample is invalidated (replaced with \texttt{NaN}). The $(x, y)$ values do not change for each frame of the image sequence, but the $(u, v)$ values could. Our fluid's flow profile appeared to be mostly constant over the time period spanned by all the frames, so we averaged all the valid $(u, v)$ values to obtain an average $(u, v)$ field. \\

%In order to find the average, we defined a new two-dimensional array in NumPy, $(u_{avg}, v_{avg})$. For each frame in the PIV data, we took the \textit{validated} $(u, v)$ pairs and added them to the corresponding positions in the $(u_{avg}, v_{avg})$ array. In the end, we needed to divide by the number of frames added in order to find the average, so we needed another array to track that; thus, we defined an array, $N_{avg}$, of the same two-dimensional size as $u_{avg}$ and $v_{avg}$, and, for each validated $(u, v)$ vector we added, we incremented the value at the corresponding pixel position in the $N_{avg}$ array. In the end, $N_{avg}$ was a grid that contained the validated counts for each pixel - see \fig{frame:apr3:use-count}. The $(u_{avg}, v_{avg})$ was finally divided by the corresponding numbers from $N_{avg}$, except no divisions by zero were attempted. In addition, while it may have been clever to do so, no attempt was made to weight the average $(u, v)$ grid by use count when analyzing the data to find velocity profiles. \\

\begin{figure}[!ht] 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-3/Setup-01/Plots/uv-field.png} 
		\caption{ Setup-1 \label{frame:apr3:s-1-uvf} } 
	\end{subfigure} 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-3/Setup-03-b/Plots/uv-field.png} 
		\caption{ Setup-3 \label{frame:apr3:s-3-uvf} } 
	\end{subfigure} 
	\caption{ Velocity field of validated vectors. \label{frame:apr3:uvf} } 
\end{figure} 

We converted the $(x, y)$ (position) and $(u, v)$ (velocity) data from pixels to millimeters by using OpenPIV's scaling function, \texttt{scaling.uniform ()}; we passed the ratio of pixels to millimeters to this scaling function. Thus, the average frame $(x, y)$ was in millimeters, and $(u, v)$ (omitting the $avg$ subscript for brevity) was in millimeters per second. The result is shown in \fig{frame:apr3:uvf}. Note, the result in \fig{frame:apr3:uvf} is centered. We needed to find the velocities' positions relative to the \textit{center} of the cylindrical flow, as that greatly impacts the accuracy of finding the velocity profile. We manually entered the center pixel's position within the frame into the code, but the code then adjusted this to minimize the radial velocity components. \\

%\begin{figure}[h] 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-3/Setup-01/Plots/filter-v_r-before-after.png} 
%		\caption{ Setup-1 \label{fig:apr3:s-1-vr-bef-aft} } 
%	\end{subfigure} 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-3/Setup-03-b/Plots/filter-v_r-before-after.png} 
%		\caption{ Setup-3 \label{fig:apr3:s-3-vr-bef-aft} } 
%	\end{subfigure} 
%	\caption{ Radial velocity, $\left( \frac{d\vec{r}}{dt} \right)_r$, before (blue) and after (green) invalidating velocity vectors whose $v_r$ is above the threshold. \label{fig:apr3:vr-bef-aft} } 
%\end{figure} 

%Although we knew the approximate center pixel position of the system, as a next step we employed an additional centering mechanism to be sure we have the right center. 

We had the code do this by using the SciPy Optimize library's \texttt{minimize ()} function. The scalar function we passed to \texttt{minimize ()} took a 2D vector representing the center position, in millimeters, and it computed a scalar that represented how close this position is to the center of the cylindrical fluid flow. It did this by first converting the $(u, v)$ Cartesian velocity into a radial velocity. Let $\vec{r}$ be the position of a PIV data sample, and $\frac{d\vec{r}}{dt}$ be its velocity. Then, to convert from Cartesian coordinates to the radial cylindrical coordinate, 

\begin{equation} 
\label{eqn:calc-vr} 
\left( \frac{d\vec{r}}{dt} \right)_r = 
	\left( \frac{d\vec{r}}{dt} \right) \cdot \hat{r} = 
	\left( \frac{d\vec{r}}{dt} \right)_x \hat{x} + \left( \frac{d\vec{r}}{dt} \right)_y \hat{y} , 
\end{equation} 

\noindent where $\hat{x} = x / \sqrt{x^2 + y^2}$, $\hat{y} = y / \sqrt{x^2 + y^2}$, and $\vec{r}$ is the ($x$, $y$) vector from PIV minus the given candidate vector for the system's center. The function passed to \texttt{minimize ()} took this field of $\left( \frac{d\vec{r}}{dt} \right)_r$ values, squared them, and averaged the result. This was the scalar that was minimized to make sure that the $\left( \frac{d\vec{r}}{dt} \right)_r$ is as close to zero as possible (circular motion only, no radial component). \\

As another validation step, our main script took the resulting center from the above procedure multiplied the mean square value by a validation parameter to obtain a threshold, 

\begin{equation} 
v_{thr} = P_{thr} \left\{ mean \left( \left( \frac{d\vec{r}}{dt} \right)_r^2 \right) \right\} , 
\end{equation} 

\noindent where we have somewhat arbitrarily chosen $P_{thr} = 0.5$. The script invalidated all $(u, v)$ entries whose radial velocity, $\left( \frac{d\vec{r}}{dt} \right)_r$, was found to be greater than this threshold velocity. After that, to ensure the best accuracy, the center position was recalculated with the new, validated velocity field, using the SciPy Optimize \texttt{minimize ()} procedure again. \\

%\fig{fig:apr3:vr-bef-aft} plots a flattened array of the $\left( \frac{d\vec{r}}{dt} \right)_r$ values before and after this extra validation step. \\

\begin{figure}[!ht] 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-3/Setup-01/Plots/param-map-v_r.png} 
		\caption{ Setup-1 \label{fig:apr3:s-1-map-vr} } 
	\end{subfigure} 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-3/Setup-03-b/Plots/param-map-v_r.png} 
		\caption{ Setup-3 \label{fig:apr3:s-3-map-vr} } 
	\end{subfigure} 
	\caption{ Radial velocity, $\left( \frac{d\vec{r}}{dt} \right)_r$, for each setup. \label{fig:apr3:param-vr} } 
\end{figure} 

\begin{figure}[!ht] 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-3/Setup-01/Plots/param-map-v_t.png} 
		\caption{ Setup-1 \label{fig:apr3:s-1-map-vt} } 
	\end{subfigure} 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-3/Setup-03-b/Plots/param-map-v_t.png} 
		\caption{ Setup-3 \label{fig:apr3:s-3-map-vt} } 
	\end{subfigure} 
	\caption{ Angular velocity, $\left( \frac{d\vec{r}}{dt} \right)_\theta$, for each setup. \label{fig:apr3:param-vt} } 
\end{figure} 

The $\left( \frac{d\vec{r}}{dt} \right)_r$ field is shown in \fig{fig:apr3:param-vr}. As can be seen, the validation has done a nice job of ensuring that the data correctly represents a circular flow, with little radial motion. \\

As a next step towards finding the angular velocity profile, we needed to find the azimuthal component of the $(u, v)$ field in cylindrical coordinates. We did that using 

\begin{equation} 
\label{eqn:calc-vt} 
\left( \frac{d\vec{r}}{dt} \right)_\theta = 
	\left( \frac{d\vec{r}}{dt} \right) \cdot \hat{\theta} = 
	\left( \frac{d\vec{r}}{dt} \right)_x \left(-\hat{y}\right) + \left( \frac{d\vec{r}}{dt} \right)_y \left(\hat{x}\right) , 
\end{equation} 

\noindent where we have used that $\hat{\theta} = -\hat{y} + \hat{x}$. From this, we found the $\left( \frac{d\vec{r}}{dt} \right)_\theta$ field, which is plotted in \fig{fig:apr3:param-vt}. \\

\begin{figure}[!ht] 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-27/Setup-1/interm-angular-velocity.png} 
		\caption{ Setup-1 \label{plot:apr3:s-1-w-interm} } 
	\end{subfigure} 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-27/Setup-3/21mA/interm-angular-velocity.png} 
		\caption{ Setup-3 \label{plot:apr3:s-3-w-interm} } 
	\end{subfigure} 
	\caption{ Measured angular velocity in log-space plotted with a linear regression fit. \label{fig:apr3:w-interm} } 
\end{figure} 

We needed to verify that our flow was Keplerian, so we fit our angular velocity profile to a power law. In order to do so, we started with the relation 

\begin{equation} 
\omega = A r^P , 
\end{equation} 

\noindent where $\omega$ is angular velocity, $r$ is radial position, and $A$ and $P$ are some constants. Taking the log of both sides reveals that $A$ and $P$ may be found by fitting a line to the log data, as 

\begin{equation} 
\left( \ln (\omega) \right) = \left( \ln (A) \right) + \left( P \right) \left( \ln (r) \right) . 
\end{equation} 

We fit the data using $P$ as the slope and $ln (A)$ as the y-intercept, and we obtained the result shown in \fig{fig:apr3:w-interm}. For details on fitting lines using least squares, see Taylor, \cite{Taylor_Error_Analysis}, and \appx{ch:lin-regr}. The velocity profile results are shown in \fig{fig:apr3:w-all}. \\

%\begin{figure}[h] 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-3/Setup-01/Plots/angular-velocity--samples-fit.png} 
%		\caption{ Setup-1 \label{plot:apr3:s-1-w-datf} } 
%	\end{subfigure} 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-3/Setup-03-b/Plots/angular-velocity--samples-fit.png} 
%		\caption{ Setup-3 \label{plot:apr3:s-3-w-datf} } 
%	\end{subfigure} 
%	\caption{ Measured angular velocity plotted with a power fit. \label{fig:apr3:w-datf} } 
%\end{figure} 

\begin{figure}[!ht] 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-27/Setup-1/angular-velocity--all.png} 
		\caption{ Setup-1 } 
	\end{subfigure} 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-27/Setup-3/21mA/angular-velocity--all.png} 
		\caption{ Setup-3 } 
	\end{subfigure} 
	\caption{ Measured angular velocity plotted with a power fit and an expected angular velocity based on \eqn{eqn:B-gen-prop} and the constant $A_p$ found in \sect{section:mtd:find-Ap}. \label{fig:apr3:w-all} } 
\end{figure} 

%For the fits, the least-squares fit was done to calculate the $F_A$ and $F_B$ fit parameters for the line equation $y = F_A + F_B x$, using the equations in \appx{ch:lin-regr}. \\






















For our fits, we fit only data within a middle radial position range because both the magnetic field and the velocity profile is complicated near the edges. We used a padding of \SI{20}{mm} from either edge of the \SI{30}{mm} to \SI{90}{mm} water range, so our fits were between radial positions of \SI{50}{mm} and \SI{70}{mm}. The data and their fits are shown in \fig{fig:apr3:w-all}. The plot also has an expectation curve, which is based on \eqn{eqn:B-gen-prop} and the $A_p$ value determined later in this thesis, in \sect{section:mtd:find-Ap}. \\

%\begin{figure}[h] 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-3/Setup-01/Plots/angular-velocity--samples-should.png} 
%		\caption{ Setup-1 \label{plot:apr3:s-1-w-dats} } 
%	\end{subfigure} 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-3/Setup-03-b/Plots/angular-velocity--samples-should.png} 
%		\caption{ Setup-3 \label{plot:apr3:s-3-w-dats} } 
%	\end{subfigure} 
%	\caption{ Measured angular velocity plotted with the expected velocity profile curve based on the magnetic field profile measured earlier. \label{fig:apr3:w-dats} } 
%\end{figure} 

Numerically, for Setup-1, the fits turned out to be 

\begin{subequations} 
\begin{equation} 
F_A = 17.17 \pm 0.06 
\end{equation} 
\begin{equation} 
F_B = -3.69 \pm 0.02 . 
\end{equation} 
\end{subequations} 

\noindent For Setup-3, they were 

\begin{subequations} 
\begin{equation} 
F_A = 4.96 \pm 0.26 
\end{equation} 
\begin{equation} 
F_B = -0.43 \pm 0.06 . 
\end{equation} 
\end{subequations} 

%\noindent and these can be converted back from the log form to the power form, as 

%\begin{equation} 
%%\omega = \left( 28496760.91446586 \pm \infty \right) r^{\left( -3.69 \pm 0.02 \right)} 
%\omega (r) = e^{\left( 17.17 \pm 0.06 \right)} r^{\left( -3.69 \pm 0.02 \right)} 
%\end{equation} 
%
%\noindent for Setup-1, and 
%
%\begin{equation} 
%%\omega = \left( 8202.17353239802 \pm \infty \right) r^{\left( -1.43 \pm 0.06 \right)} 
%\omega (r) = e^{\left( 4.96 \pm 0.26 \right)} r^{\left( -1.43 \pm 0.06 \right)} 
%\end{equation} 
%
%\noindent for Setup-3. We used the exponent notation for the coefficient up front because the uncertainty in the coefficient up front blows up due to the exponent in the uncertainty propagation of an exponential function, namely that $\delta{\left(e^x)\right)} = \delta{x} e^x$, since the coefficient is the exponent, $e^{F_A}$, which blows up to infinity. Another reason for using the exponent notation is that we really only know the front coefficient's order of magnitude, not its particular value, from our fit; thus, it semantically makes more sense to use exponent notation for that. \\

%\begin{figure}[h] 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-3/Setup-01/Plots/angular-velocity--fit-should.png} 
%		\caption{ Setup-1 \label{plot:apr3:s-1-w-fs} } 
%	\end{subfigure} 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-3/Setup-03-b/Plots/angular-velocity--fit-should.png} 
%		\caption{ Setup-3 \label{plot:apr3:s-3-w-fs} } 
%	\end{subfigure} 
%	\caption{ Angular velocity power fit plotted with the expected velocity profile curve based on the magnetic field profile measured earlier. \label{fig:apr3:w-fs} } 
%\end{figure} 

%Finally, we plotted the power fits together with the expected profiles based on the magnetic fields measured earlier, which are shown in \fig{fig:apr3:w-fs}. 

After that, we took the same data for more electric currents, as described next, in \sect{section:mtd:find-Ap}, and found how our fluid flow profile behaves. This data will be presented in the next chapter. In the meantime, in \sect{section:mtd:find-Ap}, we find the $A_p$ constant of proportionality from \eqn{eqn:B-gen-prop}. \\













\section{ Angular Velocity's Proportionality Constant to the Magnetic Field \label{section:mtd:find-Ap} } 

At this point in the analysis, we had many data samples of angular velocities calculated from PIV data, as in \fig{fig:apr3:w-all}. The samples looked like $(r, \omega (r))$. They can be related to the magnetic field using \eqn{eqn:B-gen-prop} as long as the magnetic field is known, so 

\begin{equation} 
B (r) = \frac{2 \pi z}{A_p I} r^2 \Omega (r) 
\end{equation} 

\noindent where $B (r)$ is the magnetic field and $\Omega (r)$ is the fluid's angular velocity at radial position $r$ while a current $I$ is driven through the fluid, and the fluid's thickness is $z$. The only unknown left in the experiment at this point was $A_p$. Rearranging, we obtain 

\begin{equation} 
\label{eqn:find-ap} 
A_p = \frac{2 \pi z}{I B (r)} r^2 \Omega (r) . 
\end{equation} 

%\begin{figure}[h] 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-27/Setup-1/Ap-data.png} 
%		\caption{ Setup-1 \label{plot:apr27:ap-1a} } 
%	\end{subfigure} 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-27/Setup-3/21mA/Ap-data.png} 
%		\caption{ Setup-3 \label{plot:apr27:ap-21ma} } 
%	\end{subfigure} 
%	\caption{ Samples of the RHS of \eqn{eqn:find-ap}, the mean value of which represents the $A_p$ constant. \label{fig:apr27:single-ap} } 
%\end{figure} 

At this point, finding $A_p$ was trivial because it is a simple function of the known parameters. The maximum likelihood value of $A_p$ was taken to be the mean of the RHS of \eqn{eqn:find-ap}, and the uncertainty in the found $A_p$ was the standard deviation. \\

%The RHS of \eqn{eqn:find-ap} is shown as samples for each data point for Setup-1 and Setup-3 in \fig{fig:apr27:single-ap}. \\

For Setup-1, the current was $I = \SI{1.0}{A}$, while for Setup-3 it was $I = \SI{0.021}{A}$. There was more uncertainty from the PIV data itself than from the current measurements, so the current measurements were considered to be exact, without uncertainty. For both setups, the water thickness was $z = \SI{5}{mm}$. The magnetic field for each angular velocity sample was taken as a linear interpolation of the data from \fig{img:meas-b-1} and \fig{img:meas-b-3}, using NumPy \texttt{interp ()}. Numerically, the best estimate value for $A_p$ was 

\begin{equation} 
A_p = \left( 561 \pm 15 \right) \  \frac{\si{mm}^3 \  \si{rad}}{\si{A} \  \si{G} \  \si{s}}  
\end{equation} 

\noindent from the Setup-1 data, and 

\begin{equation} 
A_p = \left( 645 \pm 15 \right) \  \frac{\si{mm}^3 \  \si{rad}}{\si{A} \  \si{G} \  \si{s}} 
\end{equation} 

\noindent from the Setup-3 data. \\

% The overall best estimate for $A_p$ from both data sets combined was 

%\begin{equation} 
%A_p = \left( N \pm N \right) \  \frac{\si{mm}^3 \  \si{rad}}{\si{A} \  \si{G} \  \si{s}} . 
%\end{equation} 

%At this point, we have obtained all the data. In the next chapter, we analyze the data (its significance?). 

% , so we obtained similar results as in \fig{fig:apr27:single-ap}

We continued taking data and analyzing PIV for more electric currents. The imaging beads in the fluid began to centrifuge outward and not show up well on PIV at high electric currents, so, for Setup-3, we only considered the data for currents less than or equal to \SI{0.5}{A}. We took a weighted average of the $A_p$ samples obtained as above. For the weighted average equations, see \appx{ch:lin-regr}. \\

































In the next chapter, we present all the high-level data from $\Omega$ (previous section) and $A_p$ (this section). 












